<?php

namespace App\Mobile\Synchronization\Controllers;

use App\Mobile\Synchronization\Resources\SyncSalesResource;
use Freelabois\LaravelQuickstart\Extendables\CrudController;
use Illuminate\Http\Request;
use Schaffen\Core\Movement\Repositories\SalesRepository;
use Schaffen\Core\Movement\Managers\SalesManager;

class SyncSalesController extends CrudController
{
    protected $resource = SyncSalesResource::class;

    public function __construct(SalesManager $manager, SalesRepository $repository)
    {
        parent::__construct($manager, $repository);
    }

    public function vendasPorVendedor(){
        $user = auth()->user();
        return SyncSalesResource::collection($this->manager->ultimasVendas($user));
    }

    public function addVenda(Request $request){
        $sanitized = $request->all();
        return new SyncSalesResource($this->manager->addVenda($sanitized));
    }

    public function cancelarVenda(Request $request){
        $sanitized = $request->all();
        return new SyncSalesResource($this->manager->cancelarVenda($sanitized));
    }
}
