<?php


namespace App\RestApi\FiscalDocument\Controllers;

use Illuminate\Http\Request;
use Schaffen\Fiscal\FiscalDocument\Managers\NfstManager;
use Schaffen\Fiscal\FiscalDocument\Repositories\NfstRepository;
use Freelabois\LaravelQuickstart\Traits\Crudable;

use Schaffen\Fiscal\FiscalDocument\Models\TelecomServiceFiscalNote;

class NfstController
{

    use Crudable;

    public function __construct(
        NfstManager $manager,
        NfstRepository $repository
    )
    {
        $this->setup($manager, $repository);
    }

    /**
     * @param Request  $request
     * @return TelecomServiceFiscalNote
     */
    public function store(Request $request): TelecomServiceFiscalNote
    {
        $sanitized = $request->all();
        return $this->manager->storeOrUpdate($sanitized);
    }

    public function destroy($id)
    {
        return $this->manager->destroy($id);
    }

    public function index(Request $request){
        $filter = $request->all();
        return $this->resource::collection($this->repository->findMany($filter));
    }

    public function geraDocumento(Request $request){
        $itens = $request->itens;
        $result = $this->manager->geraDocumento($itens);
        return $result;
    }

    

}
