<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace App\RestApi\WarehouseInventory\Controllers;

use App\RestApi\WarehouseInventory\Resources\WarehouseInventoryPersonResource;

use Illuminate\Http\Request;
use Schaffen\Core\Person\Repositories\PersonRepository;
use Schaffen\WarehouseInventory\WarehouseInventory\Repositories\SnapshotInventoryRepository;

class SnapshotInventoryPersonController
{
    /**
     * @var PersonRepository
     */
    private $person_repository;
    /**
     * @var SnapshotInventoryRepository
     */
    private $snapshot_inventory_repository;

    public function __construct(
        PersonRepository $person_repository,
        SnapshotInventoryRepository $snapshot_inventory_repository
    )
    {
        $this->person_repository = $person_repository;
        $this->snapshot_inventory_repository = $snapshot_inventory_repository;
    }

    public function index(Request $request, $person = null)
    {
        $filters = $request->all();
        $filters = array_merge($filters, ['person' => $person, 'not_zeroed' => true]);
        $result = $this->snapshot_inventory_repository->list($filters, ['product_variety_pack']);

        return WarehouseInventoryPersonResource::collection($result);
    }

}
